import { FormApi, FieldApi } from '@tanstack/form-core';
export * from '@tanstack/form-core';
import { injectStore as injectStore$1 } from '@tanstack/angular-store';
import * as i0 from '@angular/core';
import { booleanAttribute, numberAttribute, Input, Directive } from '@angular/core';

function injectForm(opts) {
    const api = new FormApi(opts);
    injectStore$1(api.store, (state) => state.isSubmitting);
    return api;
}

class TanStackField {
    name;
    defaultValue;
    asyncDebounceMs;
    asyncAlways;
    tanstackField;
    validators;
    listeners;
    defaultMeta;
    disableErrorFlat;
    api;
    getOptions() {
        return {
            defaultValue: this.defaultValue,
            asyncDebounceMs: this.asyncDebounceMs,
            asyncAlways: this.asyncAlways,
            disableErrorFlat: this.disableErrorFlat,
            validators: this.validators,
            listeners: this.listeners,
            defaultMeta: this.defaultMeta,
            name: this.name,
            form: this.tanstackField,
        };
    }
    unmount;
    ngOnInit() {
        this.api = new FieldApi(this.getOptions());
        this.unmount = this.api.mount();
    }
    ngOnDestroy() {
        this.unmount?.();
    }
    ngOnChanges() {
        const api = this.api;
        if (!api)
            return;
        api.update(this.getOptions());
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: TanStackField, deps: [], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "16.1.0", version: "19.2.14", type: TanStackField, isStandalone: true, selector: "[tanstackField]", inputs: { name: "name", defaultValue: "defaultValue", asyncDebounceMs: ["asyncDebounceMs", "asyncDebounceMs", numberAttribute], asyncAlways: ["asyncAlways", "asyncAlways", booleanAttribute], tanstackField: "tanstackField", validators: "validators", listeners: "listeners", defaultMeta: "defaultMeta", disableErrorFlat: "disableErrorFlat" }, exportAs: ["field"], usesOnChanges: true, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: TanStackField, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tanstackField]',
                    standalone: true,
                    exportAs: 'field',
                }]
        }], propDecorators: { name: [{
                type: Input,
                args: [{ required: true }]
            }], defaultValue: [{
                type: Input
            }], asyncDebounceMs: [{
                type: Input,
                args: [{ transform: numberAttribute }]
            }], asyncAlways: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], tanstackField: [{
                type: Input,
                args: [{ required: true }]
            }], validators: [{
                type: Input
            }], listeners: [{
                type: Input
            }], defaultMeta: [{
                type: Input
            }], disableErrorFlat: [{
                type: Input
            }] } });

function injectStore(form, selector) {
    return injectStore$1(form.store, selector);
}

/**
 * Generated bundle index. Do not edit.
 */

export { TanStackField, injectForm, injectStore };
//# sourceMappingURL=tanstack-angular-form.mjs.map
