import { FieldApi, FieldAsyncValidateOrFn, FieldValidateOrFn, FormApi } from '@tanstack/form-core';
import type { DeepKeys, DeepValue, FieldListeners, FieldMeta, FieldOptions, FieldValidators, FormAsyncValidateOrFn, FormValidateOrFn } from '@tanstack/form-core';
import type { OnChanges, OnDestroy, OnInit } from '@angular/core';
import * as i0 from "@angular/core";
export declare class TanStackField<TParentData, const TName extends DeepKeys<TParentData>, TData extends DeepValue<TParentData, TName>, TOnMount extends undefined | FieldValidateOrFn<TParentData, TName, TData>, TOnChange extends undefined | FieldValidateOrFn<TParentData, TName, TData>, TOnChangeAsync extends undefined | FieldAsyncValidateOrFn<TParentData, TName, TData>, TOnBlur extends undefined | FieldValidateOrFn<TParentData, TName, TData>, TOnBlurAsync extends undefined | FieldAsyncValidateOrFn<TParentData, TName, TData>, TOnSubmit extends undefined | FieldValidateOrFn<TParentData, TName, TData>, TOnSubmitAsync extends undefined | FieldAsyncValidateOrFn<TParentData, TName, TData>, TFormOnMount extends undefined | FormValidateOrFn<TParentData>, TFormOnChange extends undefined | FormValidateOrFn<TParentData>, TFormOnChangeAsync extends undefined | FormAsyncValidateOrFn<TParentData>, TFormOnBlur extends undefined | FormValidateOrFn<TParentData>, TFormOnBlurAsync extends undefined | FormAsyncValidateOrFn<TParentData>, TFormOnSubmit extends undefined | FormValidateOrFn<TParentData>, TFormOnSubmitAsync extends undefined | FormAsyncValidateOrFn<TParentData>, TFormOnServer extends undefined | FormAsyncValidateOrFn<TParentData>, TSubmitMeta> implements OnInit, OnChanges, OnDestroy, FieldOptions<TParentData, TName, TData, TOnMount, TOnChange, TOnChangeAsync, TOnBlur, TOnBlurAsync, TOnSubmit, TOnSubmitAsync> {
    name: TName;
    defaultValue?: NoInfer<TData>;
    asyncDebounceMs?: number;
    asyncAlways?: boolean;
    tanstackField: FormApi<TParentData, TFormOnMount, TFormOnChange, TFormOnChangeAsync, TFormOnBlur, TFormOnBlurAsync, TFormOnSubmit, TFormOnSubmitAsync, TFormOnServer, TSubmitMeta>;
    validators?: NoInfer<FieldValidators<TParentData, TName, TData, TOnMount, TOnChange, TOnChangeAsync, TOnBlur, TOnBlurAsync, TOnSubmit, TOnSubmitAsync>>;
    listeners?: NoInfer<FieldListeners<TParentData, TName, TData>>;
    defaultMeta?: Partial<FieldMeta<TParentData, TName, TData, TOnMount, TOnChange, TOnChangeAsync, TOnBlur, TOnBlurAsync, TOnSubmit, TOnSubmitAsync, TFormOnMount, TFormOnChange, TFormOnChangeAsync, TFormOnBlur, TFormOnBlurAsync, TFormOnSubmit, TFormOnSubmitAsync>>;
    disableErrorFlat?: boolean;
    api: FieldApi<TParentData, TName, TData, TOnMount, TOnChange, TOnChangeAsync, TOnBlur, TOnBlurAsync, TOnSubmit, TOnSubmitAsync, TFormOnMount, TFormOnChange, TFormOnChangeAsync, TFormOnBlur, TFormOnBlurAsync, TFormOnSubmit, TFormOnSubmitAsync, TFormOnServer, TSubmitMeta>;
    private getOptions;
    unmount?: () => void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TanStackField<any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TanStackField<any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any, any>, "[tanstackField]", ["field"], { "name": { "alias": "name"; "required": true; }; "defaultValue": { "alias": "defaultValue"; "required": false; }; "asyncDebounceMs": { "alias": "asyncDebounceMs"; "required": false; }; "asyncAlways": { "alias": "asyncAlways"; "required": false; }; "tanstackField": { "alias": "tanstackField"; "required": true; }; "validators": { "alias": "validators"; "required": false; }; "listeners": { "alias": "listeners"; "required": false; }; "defaultMeta": { "alias": "defaultMeta"; "required": false; }; "disableErrorFlat": { "alias": "disableErrorFlat"; "required": false; }; }, {}, never, never, true, never>;
    static ngAcceptInputType_asyncDebounceMs: unknown;
    static ngAcceptInputType_asyncAlways: unknown;
}
